#include <os.h>
#include "navigation.h"
#include "utils.h"
#include "output.h"

int go_down(char* textbuffer, int pos){
    int w = getw(textbuffer, pos);
    pos = nextline(textbuffer, pos);
    int tmpw;
    for(tmpw = 0; tmpw < w && textbuffer[pos] != '\n' && textbuffer[pos] != '\0'; pos++){
        if(textbuffer[pos] == '\t')
            tmpw += TAB_WIDTH - (tmpw % TAB_WIDTH);
        else
            tmpw++;
    }
    return pos;
}

int go_up(char* textbuffer, int pos){
    int w = getw(textbuffer, pos);
    pos = prevline(textbuffer, pos);
    int tmpw;
    for(tmpw = 0; tmpw < w && textbuffer[pos] != '\n' && textbuffer[pos] != '\0'; pos++){
        if(textbuffer[pos] == '\t')
            tmpw += TAB_WIDTH - (tmpw % TAB_WIDTH);
        else
            tmpw++;
    }
    return pos;
}
